clear
Fs   = 1024; % Hz
nyquist = Fs/2;
f  = [20 45]/nyquist;
ordem=6;

% coeficientes do filtro (baseados na equao de diferenas)
[bn,an] = butter(ordem,f);

% H(z)- PSD do kernel
psd_bn = abs(fft(bn)).^2;
% Calcula o vetor de frequencias e exibe apenas a parte positiva (simetria)
Hz      = linspace(0,Fs/2,floor(length(bn)/2)+1);
psd_bn = psd_bn(1:length(Hz));

figure(1);
subplot(2,2,1);hold on; plot(bn*1e3, 'ks-','linew',1,'markersize',4,'markerfacecolor','w');
plot(an,'rs-','linew',1,'markersize',4,'markerfacecolor','w')
xlabel('Pontos (tempo)');ylabel('Coef. do filtro')
title('Coeficientes do filtro no dom do tempo')
legend({'bn';'an'})

% H(z) (PSD)
subplot(2,2,2), hold on
stem(Hz,psd_bn(1:length(Hz)),'ks-','markerfacecolor','w')
xlabel('Frequencia (Hz)'), ylabel('H(z)')
title('PSD coeficientes')

% Obter a RI 
impulso = impseq(501,0,1000);
hn=filter(bn,an,impulso);

%obter H(z) - PSD de hn
psd_imp = abs(fft(hn)).^2;
Hz = linspace(0,nyquist,floor(length(impulso)/2)+1);

subplot(2,2,2), cla, hold on
plot(impulso,'b','linew',1)
plot(hn,'m','linew',1)
set(gca,'xlim',[1 length(impulso)],'ylim',[-1 1]*.06)
legend({'Impulso';'h[n]'})
xlabel('Pontos (tempo)')
title('RI')

% H(z)
subplot(2,2,3), hold on
plot(Hz,psd_imp(1:length(Hz)),'ms-','linew',1,'markerfacecolor','w','markersize',4)
plot([0 f(1) f(1) f(2) f(2) 1]*nyquist,[0 0 1 1 0 0],'b','linew',2)
set(gca,'xlim',[0 100])
xlabel('Frequencia (Hz)'), ylabel('Atenuao')
title('RF (Butterworth)')

% H(z) em escala logaritmica
subplot(2,2,4)
plot(Hz,10*log10(psd_imp(1:length(Hz))),'ms-','linew',1,'markerfacecolor','w','markersize',4)
set(gca,'xlim',[0 100])
xlabel('Frequencia (Hz)'), ylabel('Atenuao (log)')
title('RF (Butterworth)')